]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
backup-status: Correctly show "current" snapshot as newest
[backup-script.git] / bin / backup-script
index d28caafbc8264f5a0c89149853cd3299966c1b2c..2c6fd823704adf916c7837c673e6ff971a742e71 100755 (executable)
@@ -26,11 +26,13 @@ declare -i count_ok_vanished=0
 destinations=""
 
 # Default settings, can be overwritten in backup-script.conf:
-conf_d="/etc/backup-script.d"
+[ -d "/usr/local/etc/backup-script.d" ] \
+       && conf_d="/usr/local/etc/backup-script.d" \
+       || conf_d="/etc/backup-script.d"
 pre_exec=""
 post_exec=""
 default_source_root="/"
-default_target=""
+default_target="/var/backups"
 default_user="root"
 default_ssh_args_add=""
 default_rsync_args_add=""
@@ -50,7 +52,10 @@ Usage() {
        echo
        echo "When no <system> is given, all defined systems are used."
        echo
-       exit 1
+       echo "Configuration file is \"$conf\","
+       echo "using \"$conf_d\" as configuration directory."
+       echo
+       exit 2
 }
 
 CleanUp() {
@@ -234,10 +239,21 @@ Initialize_Last_SysTarget_Snapshot() {
                ;;
          "zfs")
                # On ZFS, the last generation is always named "current"
-               [ -e "$sys_target/current" ] \
-                       && last="$sys_target/current" \
-                       || last=""
-               snapshot="$(echo "$sys_target/current" | cut -c2-)@$(date +%Y%m%d-%H%M%S)"
+               if [ -e "$sys_target/current" ]; then
+                       last="$sys_target/current"
+                       if [ "$(uname)" = "Linux" ]; then
+                               date=$(LC_ALL=C stat "$1" | grep "^Modify: " \
+                                | cut -d':' -f2- | cut -d. -f1)
+                       else
+                               date=$(LC_ALL=C stat -f "%Sc" "$1")
+                       fi
+                       date=$(echo "$date" | sed -e's/^ //g' -e 's/[-:]//g' -e 's/ /-/g')
+
+               else
+                       last=""
+                       date="$(date +%Y%m%d-%H%M%S)"
+               fi
+               snapshot="$(echo "$sys_target/current" | cut -c2-)@$date"
                sys_target="$sys_target/current"
                ;;
          *)
@@ -247,6 +263,16 @@ Initialize_Last_SysTarget_Snapshot() {
        return 0
 }
 
+# Search configuration file (last one is used as default!)
+for conf in \
+       "/usr/local/etc/backup-script.conf" \
+       "/etc/backup-script.conf" \
+       "${conf_d}/backup-script.conf" \
+       "/usr/local/etc/backup-script.conf" \
+; do
+       [ -r "$conf" ] && break
+done
+
 while [ $# -gt 0 ]; do
        case "$1" in
          "-n"|"--dry-run")
@@ -267,19 +293,20 @@ trap GotSignal SIGINT
 
 echo -n "Started: "; date
 
-for conf in "/etc/backup-script.conf" "${conf_d}/backup-script.conf"; do
-       if [ -r "$conf" ]; then
-               echo "Reading configuration: \"$conf\" ..."
-               source "$conf"
-       fi
-done
+# Read in configuration file
+if [ -r "$conf" ]; then
+       echo "Reading configuration: \"$conf\" ..."
+       source "$conf"
+else
+       echo "No configuration file found, using defaults."
+fi
 echo
 
 if [ $# -ge 1 ]; then
        for s in "$@"; do
                if [ ! -r "${conf_d}/$s" ]; then
                        echo "$NAME: Can' read \"${conf_d}/$s\"!"
-                       exit 1
+                       exit 3
                fi
                sys="$sys ${conf_d}/$s"
        done
@@ -294,7 +321,7 @@ if [ -e "$PIDFILE" ]; then
        echo
        echo -n "Aborted: "; date
        echo
-       exit 3
+       exit 4
 fi
 touch "$PIDFILE" 2>/dev/null
 if [ $? -ne 0 ]; then
@@ -311,7 +338,7 @@ if [ -n "$pre_exec" ]; then
                echo "Error: pre-exec command failed!"; echo
                CleanUp
                echo "Aborting backup."; echo
-               exit 2
+               exit 5
        fi
        sleep 2
        echo
@@ -370,7 +397,26 @@ for f in $sys; do
        post_exec="$post_exec_saved"
 
        # Validate configuration
-       [ "$system" = "localhost" -o "$system" = "127.0.0.1" ] && local=1
+       if [ "$system" = "localhost" -o "$system" = "127.0.0.1" ]; then
+               # Local system
+               local=1
+               compress=0
+       fi
+
+       # Make sure "source" ends with a slash ("/")
+       case "$source" in
+         "*/")
+               ;;
+         "*")
+               source="$source/"
+       esac
+
+       # Make sure "target" DOESN'T end with a slash ("/")
+       case "$target" in
+         "*/")
+               target=$( echo "$target" | sed -e 's/\/$//g' )
+               ;;
+       esac
 
        [ "$system" = "$fname" ] \
                && systxt="\"$system\"" \
@@ -445,7 +491,7 @@ for f in $sys; do
                                fi
                                echo "Created new snapshot in \"$snapshot\"."
                        else
-                               echo " *** Trial run, not creating new snapshot in \"$sys_target\"!"
+                               echo " *** Trial run, not creating new snapshot in \"$snapshot\"!"
                        fi
                else
                        # No old backup found, create new subvolume
@@ -511,8 +557,7 @@ for f in $sys; do
 
        if [ $ret -eq 20 ]; then
                echo "Backup of \"$system\" interrupted. Aborting ..."
-               CleanUp
-               exit 1
+               GotSignal
        fi
 
        echo -n "End date: "; date
@@ -593,6 +638,9 @@ echo
 if [ $count_started -ne $count_ok ]; then
        echo "----->  THERE HAVE BEEN ERRORS!  <-----"
        echo
+       exit 6
+elif [ $count_all -ne $count_started ]; then
+       exit 7
 fi
 
 # -eof-